<!DOCTYPE html>
<head><title>doc</title>
    <style>
        * {
            margin: 0;
            padding: 0;
        }

        body {
            text-align: center;
        }

        h1 {
            margin-bottom: 20px;
        }

        h2 {
            margin-bottom: 20px;
        }

        .add_user {
            margin-bottom: 50px;
        }

        .users_list .user_card {
            margin-bottom: 20px;
        }

        .delete_user {
            margin-bottom: 50px;
        }
    </style></head>
<body>
    <h2>Список користувачів</h2>
    <div class="users_list"></div>
    <div class="add_user">
        <form action="" onsubmit="return false" id="add_form">
            <input type="number" id="user_code" placeholder="Код">
            <input type="text" id="user_full_name" placeholder="ПІБ">
            <input type="text" id="user_position" placeholder="посада">
            <input type="text" id="user_salary" placeholder="заробітна плата">
            <input type="text" id="user_number_of_children" placeholder="кількість дітей">
            <input type="text" id="user_experience" placeholder="стаж">
            <button id="add_btn" class="btn btn-primary">Добавити користувача</button>
        </form>
    </div>
    <div class="delete_user">
        <form action="" onsubmit="return false">
            <input type="text" id="delete" placeholder="ПІБ">
            <button id="delete_btn" class="btn btn-danger">Видалити користувача</button>
        </form>
    </div>
    <div class="change_user">
        <form action="" onsubmit="return false">
            <input type="text" id="change_full_name" placeholder="ПІБ">
            <input type="text" id="change_position" placeholder="посада">
            <input type="text" id="change_salary" placeholder="заробітна плата">
            <input type="text" id="change_number_of_children" placeholder="кількість дітей">
            <input type="text" id="change_experience" placeholder="стаж">
            <button id="change_btn" class="btn btn-primary">Змінити користувача</button>
        </form>
    </div>
    <script>
    class Accounting{
        constructor(code, fullname, position,salary, numberofchildren,experience) {
            this.code = code;
            this.fullname = fullname;
            this.position = position;
            this.salary = salary;
            this.numberofchildren = numberofchildren;
            this.experience = experience;
            
            
        }
        }
        class Accountings{
            constructor(){
                this.accountants=[];
            }
            toString() {
            let res = "";
            for (let user of this.accountants) {
                res += user.fullname + " ";
            }
            return res;
        }

        checkUsers(user_full_name) {
            let index = this.accountants.findIndex(user => user.fullname === user_full_name);
            if (index === -1) {
                return true;
            } else {
                return false;
            }
        }
        
        
        
        add(object){
            if(object instanceof Accounting){
                this.accountants.push(object);
            }
        }
        
        
        delete(fullname) {
            let index = this.accountants.findIndex(user => user.fullname === fullname);
            if (index > -1) {
                this.accountants.splice(index, 1);
            }
        }
        changeUser(fullname) {
            let new_position = document.querySelector("#change_position").value;
            let new_salary = document.querySelector("#change_salary").value;
            let new_full_name = document.querySelector("#change_full_name").value;
            let new_number_of_children = document.querySelector("#change_number_of_children").value;
            let new_experience = document.querySelector("#change_experience").value;
            let index = this.trafficPolice.findIndex(user => user.fullname === fullname);
            if (index > -1) {
                if (new_position !== "") {
                    this.accountants[index].position = new_position;
                }
                if (new_salary !== "") {
                    this.accountants[index].salary = new_salary;
                }
                if (new_full_name !== "") {
                    this.accountants[index].fullname = new_full_name;
                }
                if (new_number_of_children !== "") {
                    this.accountants[index].numberofchildren = new_number_of_children;
                }
                if (new_experience !== "") {
                    this.accountants[index].experience = new_experience;
                }
            } else {
                alert("Такого користувача не існує");
            }
        }

        }
    let New = new Accountings();

document.querySelector("#add_btn").addEventListener('click', () => {
    let code = document.querySelector("#user_code").value;
    let fullname = document.querySelector("#user_full_name").value;
    let position = document.querySelector("#user_position").value;
    let salary = document.querySelector("#user_salary").value;
    let numberofchildren = document.querySelector("#user_number_of_children").value;
    let experience = document.querySelector("#user_experience").value;
    if (New.checkUsers(fullname)) {
        let new_user = new Accounting(code, fullname, position,salary, numberofchildren,experience);
        New.add(new_user);
        showUsers(New);
        alert("Користувача успішно додано");
    } else {
        alert("Такий користувач вже існує");
    }
});

const showUsers = function (list) {
    let card_holder = document.querySelector(".users_list");
    card_holder.innerHTML = "";
    for (let user of list.accountants) {
        card_holder.innerHTML += `<div class='user_card'><h3 class='user_card_full_name'>${user.fullname}</h3><h3 class='user_card_full_name'>${user.numberofchildren}</h3></div>`;
    }
};

document.querySelector("#delete_btn").addEventListener('click', () => {
    let del_full_name = document.querySelector("#delete").value;
    New.delete(del_full_name);
    console.log(New.accountants);
    showUsers(New);
});

document.querySelector("#change_btn").addEventListener('click', () => {
    let change_full_name = document.querySelector("#change_full_name").value;
    New.changeUser(change_full_name);
    console.log(New.accountants);
    showUsers(New);
});
        </script>
</body>
